#include <iostream.h>
#include "apstring.h"

// This program implements a three function calculator
// as the first step to a test program for the BigInt class
//

enum   Optype { add, subtract, multiply, stop, illegal_op };

Optype StringToOp(const apstring & s);
Optype GetOperator();

int main()
{
    int accumulator = 0;           // accumulate in this object
    int current;                   // value to be operated with
    Optype op = add;               // so first value is added to zero
   
    while (op != stop)
    {
        cout << "enter value: ";
        cin >> current;
        switch (op)
        {
          case add :
             accumulator += current;
             break;
           case subtract:
             accumulator -= current;
             break;
           case multiply:
             accumulator *= current;
             break;
           default:
             cerr << "error with operator" << endl;
        }
        cout << "----> " << accumulator << endl;
        op = GetOperator();
    }
    return 0;
}

Optype StringToOp(const apstring & s)
// precondition:   s is a valid operator
// postcondition: returns Optype equivalent, e.g., add for "+"
{
    // define array of strings to facilitate look up
    // built-in arrays are NOT part of AP C++ subset
    
    apstring OPSTRINGS[] = {"+", "-", "*", "=" };
    const int NUMOPS = 4;    // # valid operations
    
    int k;
    for(k=0;k < NUMOPS; k++)
    {
        if (s == OPSTRINGS[k]) return Optype(k);
    }
    return illegal_op;   // not found, return illegal_op
}

Optype GetOperator()
// postcondition: reads a whitespace delimited operator from cin
//                and returns the operator 
{
    apstring s;
    Optype retval;
    do
    {
        cout << "enter + - * ( = to quit) ";
        cin >> s;
    } while ((retval = StringToOp(s)) == illegal_op);

    return retval;
}
