#include <iostream.h>
#include "date.h"
#include "prompt.h"

// illustrates use of date class to make calendar
// Owen Astrachan

const int FIELD_WIDTH = 3;          // space calendar out

void Calendar(int month, int year)
// precondition: 1752 < year and 1 <= month <= 12     
// postcondition: print calendar for given month in given year
{

    int k;
    Date d(month,1,year);              // start on first day of month
	 int firstDay = int(d.Absolute() % 7);   // 0=sunday, 1=monday, etc.
    int numDays = d.DaysIn();          // # of days in month

    cout.width(FIELD_WIDTH);           // print spaces, then month name
    cout << " ";
    cout << d.MonthName() << " " << year << endl;  

    cout << " Su Mo Tu We Th Fr Sa" << endl;    // print header    
    for(k=0; k < firstDay;k++)          // print leading blanks
    {
        cout.width(FIELD_WIDTH);
        cout << " ";
    }
        // print rest of days;

    for(k=1; k <= numDays; k++)         // print every day in month
    {    
        cout.width(FIELD_WIDTH);        // print day in field properly
        cout << k;
        if (d.DayName() == "Saturday")
        {
            cout << endl;
        }
        d++;
    }

    if (d.DayName() != "Saturday")      // finish off last line if necessary
    {
        cout << endl;
    }
}

int main()
{
    int month = PromptRange("enter month",1,12);
    int year  = PromptRange("enter year",1752,2500);
    
    Calendar(month,year);
    return 0;
}
