#include <iostream.h>
#include "heart.h"
#include "monitor.h"
#include "prompt.h"

// skeleton program for heart monitor program
// written: 9/8/93
// modified 1/17/94, 7/1/96
//
// Owen Astrachan     
     
void Operate(Heart & theHeart,Monitor & m);    // do work of heart sensing

int main()
{
    Monitor m;
    Heart theHeart(m);        // initialize heart with monitor

    theHeart.SetFile(PromptString("enter filename: "));
    Operate(theHeart,m);         // monitor the heart

    return 0;
}

void Operate(Heart & theHeart, Monitor & m)
// precondition: heart is properly formed
// postcondition: heart is monitored until all beats have been processed
{

    int newSense;
    m.TurnOn();

    while (theHeart.IsBeating())
    {
        newSense = theHeart.Sense();
        if (newSense < MIN_VOLT || MAX_VOLT < newSense)
        {
            cout << "ERROR: bad voltage reading: " << newSense << endl;
        }
    }
    theHeart.Shock(Heart::SpeedUp);
}
