#include <iostream.h>
#include <fstream.h>              // for ifstream
#include <stdlib.h>               // for exit, atoi
#include "apstring.h"
#include "clockt.h"
#include "prompt.h"

// reads file containing data for a cd in format below (one line/track)
//        track time (Min:Sec) Title of Track 
// and sums all track times
//
// Owen Astrachan, August 4, 1994

int main()
{
    ifstream input;
    apstring filename = PromptString("enter name of data file: ");
    input.open(filename.c_str());

    if (input.fail())
    {
        cerr << "could not open file " << filename << endl;
        exit(0);
    }
    
    apstring minutes,          // # of minutes of track
           seconds,          // # of seconds of track
           title;            // title of track

    ClockTime total(0,0,0);  // total of all times
    
    while (getline(input,minutes,':') &&
           getline(input,seconds,' ') &&
           getline(input,title))               // reading line ok
    {
        cout << minutes << " " << seconds << " " << title << endl;
        ClockTime track(atoi(seconds.c_str()),atoi(minutes.c_str()));
        total += track;
    }
    cout << "------------------------------" << endl;
    cout << "total = " << total << endl;
    return 0;
}
