#include <iostream.h>
#include <fstream.h>
#include "apstring.h"
#include "prompt.h"

// Owen Astrachan 7/4/1996
// state-machine approach for removing all // comments from a file
// (doesn't handle // in a string, e.g., " test // comment "

const char SLASH = '/';
const char NEWLINE = '\n';
void Echo(char ch);

int main()
{
    enum ReadState {
        TEXT, FIRST_SLASH, COMMENT
    };

    ReadState currentState = TEXT;
    apstring filename = PromptString("enter filename: ");
    ifstream input;
    apstring extra;            // for storing extra chars on a comment line
    char ch;
    input.open(filename.c_str());

    while (input.get(ch))              // read one char at a time
    {
        switch(currentState)
        {
          case TEXT:
            if (ch == SLASH)           // potential comment begins
            {
                currentState = FIRST_SLASH;
            }
            else
            {
                Echo(ch);
            }
            break;
            
          case FIRST_SLASH:
            if (ch == SLASH)
            {
                currentState = COMMENT;
            }
            else   // one slash not followed by another
            {
                Echo(SLASH);            // print the slash from last time
                Echo(ch);               // and the current character
                currentState = TEXT;    // reading uncommented text
            }
            break;

          case COMMENT:
            if (ch == NEWLINE)          // end-of-line is end of comment
            {
                Echo(NEWLINE);          // be sure to echo end of line
                currentState = TEXT;
            }
	    break;
        }
	 }
    return 0;
}

void Echo(char ch)
{
    cout << ch;
}
