#include <iostream.h>
#include "ctimer.h"
#include "prompt.h"

const int FACT_LIMIT = 20;

long int RecFactorial(int num)
// precondition: 0 <= num
// postcondition: returns num! (num factorial)
{
    if (0 == num)
    {
        return 1;
    }
    else
    {
        return num * RecFactorial(num-1);
    }
}

long int Factorial(int num)
// precondition: 0 <= num
// postcondition: returns num! (num factorial)     
{
    long int product = 1;
    int count;
    for(count=1; count <= num; count++)
    {          
        product *= count;
    }
    return product;
}

int main()
{
    CTimer rtimer,itimer;
	 int j;
	 long int k;
    long int val1,val2;
	 long int iters = PromptRange("enter # of iterations",1L,1000000L);
    
    for(k=0; k < iters; k++)    // compute factorials specified # of times
    {

        for(j=0; j <= FACT_LIMIT; j++)
        {
            rtimer.Start();                   // time recursive version
            val1 = RecFactorial(j);
            rtimer.Stop();

            itimer.Start();                   // time iterative version
            val2 = Factorial(j);
            itimer.Stop();

            if (val1 != val2)                 // note any differences
            {
                cout << "calls differ for " << j << endl;
                cout << "recursive = " << val1
                     << " iterative = " << val2 << endl;
            }
        }
    }
    cout << iters << " recursive trials " << rtimer.CumulativeTime() << endl;
    cout << iters << " iterative trials " << itimer.CumulativeTime() << endl;
    return 0;    
}
