#include <iostream.h>
#include "ctimer.h"
#include "prompt.h"

// Illustrates "bad" recursion for computing Fibonacci numbers
// Owen Astrachan 7/28/95

const int FIB_LIMIT = 20;            // largest fib # calculated

long int RecFib(int n)
// precondition: 0 <= n
// postcondition: returns the n-th Fibonacci number
{
    if (0 == n || 1 == n)
    {
        return 1;
    }
    else
    {
        return RecFib(n-1) + RecFib(n-2);
    }
}

long int Fib(int n)
// precondition: 0 <= n
// postcondition: returns the n-th Fibonacci number
{
    long int first = 1;
    long int second = 1;
    long int temp;
    int k;
    for(k=0; k < n; k++)
    {
        temp = first;
        first = second;
        second = temp + second;
    }
    return first;
}

int main()
{
    CTimer rtimer,itimer;
	 int j;
	 long int k;
    long int val1, val2;
	 long int iters = PromptRange("enter # of iterations",1L,100000L);
    
    for(k = 0; k < iters; k++)
    {
        for(j=0; j <= FIB_LIMIT; j++)
        {
            rtimer.Start();
            val1 = RecFib(j);
            rtimer.Stop();

            itimer.Start();
            val2 = Fib(j);
            itimer.Stop();
            if (val1 != val2)
            {
                cout << "calls differ for " << j << endl;
                cout << "recursive = " << val1
                    << " iterative = " << val2 << endl;
            }
        }
        
    }
    cout << iters << " recursive trials " << rtimer.CumulativeTime() << endl;
    cout << iters << " iterative trials " << itimer.CumulativeTime() << endl;
    return 0;
}
