#include <iostream.h>
#include <fstream.h>
#include "apstring.h"
#include "worditer.h"
#include "prompt.h"

// compute authorship fingerprint for a sequence of
// files specified by the user
// author: Owen Astrachan, June 15, 1994, modified 6/28/96

const int SMALL_SIZE = 4;            // small words < this many letters
const int LARGE_SIZE = 7;            // large words > this many letters
                                     // so SMALL <= medium <= LARGE

const apstring FILE_SENTINEL = "none"; // string for no more files to process

 // function prototype(s)

void FingerPrint(apstring filename, int & small, int & medium, int & large);
void Output(apstring label, int amount, int total);

int main()
{
    apstring filename;
    int smallCount,mediumCount,largeCount,total;    

    while ((filename = PromptString("enter name of file (\"" +
                                    FILE_SENTINEL + "\" to exit): "))
           != FILE_SENTINEL)
    {
        FingerPrint(filename,smallCount,mediumCount,largeCount);
        total = smallCount + mediumCount + largeCount;

        cout << "data for " << filename << endl;
        Output("small",  smallCount,  total);
        Output("medium", mediumCount, total);
        Output("large",  largeCount,  total);
    }
    return 0;
}

void FingerPrint(apstring filename, int & small, int & medium, int & large)
// precondition: filename = name of file that can be opened for reading
// postcondition: small  = # of words of length < SMALL_SIZE
//                medium = # of medium length words
//                large  = # of words of length > LARGE_SIZE
{
    WordStreamIterator wstream;
    wstream.Open(filename);

    small = medium = large = 0;              // initialize counters
    for(wstream.First(); ! wstream.IsDone(); wstream.Next())
    {
        if (wstream.Current().length() < SMALL_SIZE)
        {
            small++;
        }
        else if (wstream.Current().length() > LARGE_SIZE)
        {
            large++;
        }
        else
        {
            medium++;
        }
    }
}

void Output(apstring label,int amount, int total)
// precondition: total != 0
// postcondition: prints amount, and amount/total nicely formatted
{
    cout << "\t # of " << label << " words = \t" << amount;
    cout << " =\t" << double(amount)*100/total << "%" << endl;    
}
     
