#ifndef _FROG_H
#define _FROG_H

// class for random-walking frog
//
// accessor functions:
//
// int GetPosition() -- returns x coordinate of frog
//
// int GetSteps()    -- returns total # steps taken
//
// mutator functions:
//
// void TakeStep()   -- take one step of random walk

#include "dice.h"

class frog
{
  public:
    frog( );             // constructor, parameter = max # steps

    // accessor functions

    int getPosition() const;        // returns position (x coord) of frog
    int getSteps()    const;        // returns # of steps taken by frog

    // mutator functions

    void takeStep();                // simulate one step of walk

  private:

    // instance variables needed here
    int myPosition;
    int mySteps;
    Dice myDice;
    };
#include "frog.cpp"
#endif
