#include <iostream.h>
#include <iomanip.h>          // for setw
#include <limits.h> 
#include "apstring.h"

// illustrates range of values for integral types
// author: Owen Astrachan, date: 8/2/94

const int FIELD_SIZE = 13;            // size of field for output chunk

void Print(apstring type, long int low, unsigned long int high);

int main()
{
    cout << setw(FIELD_SIZE) << "type"
         << setw(FIELD_SIZE) << "low"
         << setw(FIELD_SIZE) << "high" << endl << endl;

    Print("char",CHAR_MIN,CHAR_MAX);
    Print("uchar",0,UCHAR_MAX);
    Print("short",SHRT_MIN,SHRT_MAX);
    Print("ushort",0,USHRT_MAX);
    Print("int",INT_MIN,INT_MAX);
    Print("uint",0,UINT_MAX);
    Print("long",LONG_MIN,LONG_MAX);
    Print("ulong",0,ULONG_MAX);
    return 0;
}

void Print(apstring type, long int low, unsigned long int high)
// postcondition: values printed in field width FIELD_SIZE
{
    cout << setw(FIELD_SIZE) << type
         << setw(FIELD_SIZE) << low
         << setw(FIELD_SIZE) << high << endl;
}
