#include <iostream.h>

// exponentiation using logarithmic number of multiplications
// Owen Astrachan

double Power(double base, int expo)
// precondition: expo >= 0     
// postcondition: returns base^expo (base to the power expo)
{
    if (0 == expo)
    {
        return 1.0;                           // correct for zeroth power
    }
    else
    {
        double semi = Power(base,expo/2);     // build answer from this
        
        if (expo % 2 == 0)                    // even exponent
        {
            return semi*semi;
        }
        else                                  // odd exponent
        {
            return base*semi*semi;
        }       
    }
}

int main()
{
    int expo;
    double base,result;
    
    cout << "enter base and exponent: ";
    cin >> base >> expo;
    
    result = Power(base,expo);
    
    cout << base << " ** " << expo
         << " = " << result << endl;

    return 0;
}
