#include <iostream.h>
#include "worditer.h"
#include "apstring.h"
#include "prompt.h"

// illustrates nested loops using WordStreamIterator class
// to find the word that occurs most often in a file
//
// Owen Astrachan
// 2/13/96

int main()
{
    int max = 0;
    apstring word,maxWord; 
    apstring filename = PromptString("enter file name: ");
    WordStreamIterator outer,inner;
    
    outer.Open(filename);         // open two iterators
    inner.Open(filename);
    
    for(outer.First(); ! outer.IsDone(); outer.Next())
    {
        word = outer.Current();       // current word for comparison
        int count = 0;                // count # occurrences
        
        for(inner.First(); ! inner.IsDone(); inner.Next())
        {
            if (inner.Current() == word)   // found another occurrence
            {
                count++;
            }
        }
        if (count > max)                   // maximal so far
        {
            max = count;
            maxWord = word;
        }
    }
    cout << "word \"" << maxWord << "\" occurs " << max << " times" << endl;
    return 0;
}
