#include <iostream.h>
#include <iomanip.h>
#include "monitor.h"

Monitor::Monitor()
  : myIsOn(false)
// postcondition: display is off     
{
}

void Monitor::TurnOn()
// postcondition: display is on
{
    myIsOn = true;
}
void Monitor::TurnOff()
// postcondition: display is off     
{
    myIsOn = false;
}
void Monitor::DisplaySense(apstring sense)
// postcondition: sense is displayed (if display enabled/on)
{
    // all doubles printed must have two digits to right of decimal
    cout << setiosflags(ios::fixed) << setprecision(2);   

    if (myIsOn)
    {
	cout << "monitor sense: " << sense << endl;
    }
}
void Monitor::DisplayShock(apstring shock)
// postcondition: shock is displayed (if display enabled/on)
{
    if (myIsOn)
    {
	cout << shock << endl;
    }
}
