#include <iostream.h>
#include <math.h>

// illustrates structs to define a point in two dimensions
// Owen Astrachan, 7/13/96

struct Point
{
    double x;         // x-coordinate
    double y;         // y-coordinate

    Point();            // constructors
    Point(double xval, double yval);
};

Point::Point()
 : x(0.0), y(0.0)
// postcondition: point initialized at origin
{ }     

Point::Point(double xval, double yval)
 : x(xval), y(yval)
// postcondition: point initialized at (xval,yval)     
{ }

double Distance(const Point & p, const Point & q);
     
int main()
{

    Point p;
    Point q(-1.0, 1.0);
    
    cout << p.x << " " << p.y << endl;

    p.x = 1.3;        // change coordinates of p
    p.y = 2.4;

    cout << p.x << " " << p.y << endl;
    cout << q.x << " " << q.y << endl;
    cout << "distance between = " << Distance(p,q) << endl;
    
    return 0;
}

double Distance(const Point & p, const Point & q)
// postcondition: returns distance between points p and q     
{
    double xdist = p.x - q.x;
    double ydist = p.y - q.y;
    return sqrt(xdist*xdist + ydist*ydist);
}
