#include <iostream.h>
#include <iomanip.h>

// illustrates output formatting using manipulators and
// stream member functions
// author: Owen Astrachan, 8/2/94

void Print(double num, int digits);

int main()
{
    const double MY_PI = 3.141592653589793238462643383279;    // too much PI
    const MAX_DIGITS = 25;                     // max digits to print

    cout << "default PI = " << MY_PI << endl;

    cout.setf(ios::fixed);         // don't use scientific notation
    cout.setf(ios::showpoint);     // show all decimal places
    
    int digits; 
    for(digits = 0; digits <= MAX_DIGITS; digits += 1)
    {
        Print(MY_PI,digits);
    }
    return 0;
}

void Print (double num, int digits)
// precondition: digits >= 0
// postcondition: num printed with precision = digits     
{
    cout << "precision = " << digits << "\t";

    cout.precision(digits);
    cout << num << endl;
}

