#ifndef _PROMPT_H
#define _PROMPT_H

#include "apstring.h"

// facilitates prompting for int, double or string
// Owen Astrachan
// 1/8/95
//
// PromptRange: used for int or double entry
//
// int PromptRange(string prompt,int low, int high)
//                             -- returns int in range [low..high]
// Example:
//  int x = PromptRange("enter weekday",1,7);
//
// generates prompt: enter weekday between 1 and 7
//
// double PromptRange(string prompt,double low, double high)
//                             -- returns int in range [low..high]
// Example:
//   double d = PromptRange("enter value",0.5,1.5);
//
// generates prompt: enter value between 0.5 and 1.5
//
// string PromptString(string prompt)
//                             -- returns a string
// Example:
//   string filename = PromptString("enter file name");


int PromptRange(apstring prompt,int low, int high);
// precondition: low <= high
// postcondition: returns a value between low and high (inclusive)

long int PromptRange(apstring prompt,long int low,long int high);
// precondition: low <= high
// postcondition: returns a value between low and high (inclusive)

double PromptRange(apstring prompt,double low, double high);
// precondition: low <= high
// postcondition: returns a value between low and high (inclusive)


apstring PromptString(apstring prompt);
// postcondition: returns string entered by user
#endif
