#include <iostream.h>
#include "apvector.h"
#include "prompt.h"

// Illustrates "bad" recursion for computing  Fibonacci numbers
// but made better using a static apvector for storing values
// Owen Astrachan 7/28/95

const int FIB_LIMIT = 40;
int gFibCalls = 0;

long int RecFib(int n)
// precondition: 0 <= n
// postcondition: returns the n-th Fibonacci number
{
    static apvector<int> storage(FIB_LIMIT+1,0);

    gFibCalls++;
    if (0 == n || 1 == n)
    {
        return 1;
    }
    else if (storage[n] == 0)
    {
        storage[n] = RecFib(n-1) + RecFib(n-2);
        return storage[n];
    }
    else
    {
        return storage[n];
    }
}

int main()
{
    int num = PromptRange("compute Fibonacci #",1,FIB_LIMIT);
    cout << "Fibonacci # " << num << " = " << RecFib(num) << endl;
    cout << "total # function calls = " << gFibCalls << endl;    
    return 0;
}
