#include <iostream.h>
#include "dice.h"
#include "prompt.h"

// simulate rolling two dice to obtain specified sum
// repeat the "experiment" specified number of times
// Owen Astrachan, 8/9/94, modified 6/9/95

int NumToRoll(int target);

int main()
{
    int numTimes;                       // for one trial
    long int totalRolls;                // accumulate for all trials
    int targetSum;                      // roll to get this value
    int k;

    targetSum = PromptRange("roll to get what number with two dice:",2,12);
    numTimes  = PromptRange("number of experiments",1,20000);

    totalRolls = 0; 
    k = 0;
    while (k < numTimes)
    {
        totalRolls += NumToRoll(targetSum);
        k += 1;
    }

    cout << "average # of rolls to obtain " << targetSum;
    cout << " = " << totalRolls/numTimes;
    cout << " (in " << numTimes << " trials)" << endl;

    return 0;
}

int NumToRoll(int target)
// precondition: 2 <= target <= 12
// postcondition: returns # of rolls needed to obtain target
{
    Dice d1(6);
    Dice d2(6);
    
    int numRolls = 1;                 //first time through loop is 1 roll
    
    while (d1.Roll() + d2.Roll() != target)
    {
        numRolls += 1;
    }
    
    return numRolls;
}
