#ifndef _STATUSBAR_H
#define _STATUSBAR_H

#include "canvas.h"
#include "mathutils.h"
#include "ctimer.h"
#include "strutils.h"
#include "clockt.h"

class StatusBar
{
  public:
    StatusBar(int length);
   
    void SetColor(const CanvasColor& c);
    
    void update(double percent);
    void draw();
 
  private:
    
    static const int WIDTH;
    
    BaseCanvas  myCanvas;
    CanvasColor myColor;
    double      myCurrent;
    Point       myPoint;
    int         myLength;
};

class StatusCircle : public EmptyShape
{
  public:
    StatusCircle(int size);
    
    void SetColor(const CanvasColor& c);
    
    void draw(AnimatedCanvas& c);
    void update(double percent);
 
  private:
    
    static const int WIDTH;
    
    AnimatedCanvas      myCanvas;
    CanvasColor myColor;
    double      myCurrent;
    Point       myPoint;
    int         myRadius;
    CTimer      myTimer;
    int         myTime;
};

#endif
