#include <iostream.h>
#include "apstring.h"
#include "apvector.h"

// illustrates linked list concepts with list of Strings
// compares to vector
// author : Owen Astrachan
//          11/26/94
//modified: 1/10/96

struct StringNode
{
    apstring info;                   // stores information
    StringNode * next;             // pointer to next node
};

void Print(StringNode * list);
void Print(const apvector<apstring> & list);

int main()
{
    StringNode * list=0;            // initialize to 0 for safety
    StringNode * last=0;
    int k;    
    apvector<apstring> vec(4);
    
    apstring storage[] = {"I", "learn", "to", "code"};

    // assign values to each vector element

    for(k=0; k < 4; k++)
    {
        vec[k] = storage[k];
    }
    // assign values to each linked list element
    // fencepost problem, create first node

    list = new StringNode;              // create new node
    list->info = storage[0];            // info = "I"
    list->next = 0;                     // node points to 0
    last = list;                        // invariant: last points to last node
    for(k=1; k < 4; k++)
    {
        last->next = new StringNode;    // create new node
        last = last->next;              // advance to created node
        last->info = storage[k];        // assign values
        last->next = 0;
    }

    cout << "vector:\t\t";
    Print(vec);

    cout << "linked list:\t";
    Print(list);
    return 0;
}

void Print(StringNode * list)
// precondition: list is 0-terminated (last node's next field is 0)
// postcondition: all info fields of list printed on one line
{
    while (list != 0)
    {
        cout << list->info << " ";
        list = list->next;         // move to next node
    }
    cout << endl;
}

void Print(const apvector<apstring> & list)
{
    int k;
    int len = list.length();
    for(k=0; k < len; k++)
    {
        cout << list[k] << " ";
    }
    cout << endl;
}
