#include <iostream.h>
#include "apstring.h"
#include "directry.h"
#include "prompt.h"

// Owen Astrachan, 4/18/95
// print all entries in a directory (uses recursion)

void Tab(int count)
// postcondition: count tabs printed to cout
{
    int k;
    for(k=0; k < count; k++)
    {
        cout << "\t";
    }
}

void ProcessDir(const apstring & path, int tabCount)
// precondition: path specifies pathname to a directory
//               tabCount specifies how many tabs for printing
// postcondition: all files and subdirectories in directory 'path' 
//                printed, subdirectories tabbed over 1 more than parent
{
    DirStream indir;      
    DirEntry entry;
    int num = 0;              // number of files in this directory
    indir.open(path);

    if (! indir.fail())       // directory opened successfully?
    {
        // check every entry in directory 'path'
        
        for(indir.First(); ! indir.IsDone(); indir.Next())
        {
            entry = indir.Current();   // either file or subdirectory
            
            // don't process self: ".", or parent directory: ".."
            
            if (entry.Name() != "." && entry.Name() != "..")
            {
                num++;
                Tab(tabCount);                   // print spaces
                cout << "(" << num << ") "
                     << entry.Name() << endl;    // and name
                
                if (entry.IsDir() )              // process subdir
                {
                    // set path to subdirectory for recursive call
                    
                    ProcessDir(path + DIR_SEPARATOR + entry.Name(),
                               tabCount+1);
                }           
            }
        } 
    } // end if (! fail)
}

int main()
{
    apstring dirname = PromptString("enter directory name ");
    ProcessDir(dirname,0);
    return 0;
}
