#include <iostream.h>
#include "bigint.h"

// Owen Astrachan 7/5/96
// illustrates parsing arithmetic expressions with BigInt values

// define enumerated type and string equivalent of each value

enum   Optype { add, subtract, multiply, divide, stop, no_op };
apstring OPSTRINGS[] = {"+", "-", "*", "/", "=" };

const int NUMOPS = 5;    // # valid operations

Optype StringToOp(const apstring & s);
Optype Getop();

int main()
{
    BigInt accumulator(0);            // accmulate in this object
    BigInt current;                   // value to be operated with
    Optype op = add;                  // so first value is added to zero
    cout << "starting value: ";
    cin >> current;
    do
    {
        switch (op)
        {
          case add :
             accumulator += current;
             break;
           case subtract:
             accumulator -= current;
             break;
           case multiply:
             accumulator *= current;
             break;
           case divide:
             accumulator /= current;
             break;
           default:
             cerr << "error with operator" << endl;
        }
        cout << "--> " << accumulator << endl;
        op = Getop();
        if (op != stop)
        {
            cout << "enter number: ";
            cin >> current;         
        }
    } while (op != stop);
}

Optype StringToOp(const apstring & s)
// precodition:   s is a valid operator
// postcondition: returns Optype equivalent, e.g., add for "+"
{
    int k;
    for(k=0;k < NUMOPS; k++)
    {
        if (s == OPSTRINGS[k]) return Optype(k);
    }
    return no_op;   // not found, return no-operator
}

Optype Getop()
// postcondition: reads a whitespace delimited operator from cin
//                and returns the operator 
{
    apstring s;
    Optype retval;
    do
    {
        cout << "enter + - * / ( = to quit) ";
        cin >> s;
    } while ((retval = StringToOp(s)) == no_op);

    return retval;
}
