#include <iostream.h>
#include "apstring.h"

// illustrates templated node class
// Owen Astrachan, 1/27/96

template <class Type>
struct TNode
{

    TNode() : next(0)           // default constructor
    { }
    TNode(const Type & val, TNode<Type> * link=0)
        : info(val),
          next(link)
    { }
    Type info;                  // information
    TNode<Type> * next;         // points to next node
};


template <class Type>
void Print(TNode<Type> * list)
// postcondition: all values in list printed on one line
{	
    while (list != 0)
    {
        cout << list->info << " ";
        list = list->next;
    }
    cout << endl;
}

int main()
{
    TNode<apstring> * slist = new TNode<apstring>("apple");
    TNode<int>    * ilist = new TNode<int>(123);

    slist->next = new TNode<apstring>("guava");
    slist->next->next = new TNode<apstring>("orange");
    
    ilist->next = new TNode<int>(456);
    ilist->next->next = new TNode<int>(789);

    Print(slist);
    Print(ilist);
    return 0;
}
