#include <iostream.h>
#include <math.h>           // for sqrt

// Owen Astrachan
// nested loops to print wind-chill chart
//
// idea: Programming with Class by Kamin and Reingold, McGraw-Hill
// formula for wind-chill from
// UMAP Module 658, COMAP, Inc., Lexington, MA 1984, Bosch and Cobb

double WindChill(double temperature, double windSpeed);

int main()
{
    const int WIDTH = 5;
    int temp,wind,chill;

    // print column headings
    
    cout << "degrees F: ";
    for(temp = 50; temp >= -60; temp -=10)
    {
        cout.width(WIDTH);
        cout << temp;
    }
    cout << endl << endl;

    // print table of wind chill temperatures
    
    for(wind = 0; wind <= 50; wind += 5)
    {
        cout.width(WIDTH);                        // row heading
        cout << wind << " mph: ";
        
        for (temp = 50; temp >= -60; temp -= 10)  // print the row
        {
            chill = int(WindChill(temp,wind));
            cout.width(WIDTH);
            cout << chill;
        }
        cout << endl;
	 }
    return 0;
}

double WindChill(double temperature, double windSpeed)
// precondition: temperature in degrees Fahrenheit
// postcondition: returns wind-chill index/comparable temperature
{
    if (windSpeed <= 4)          // low wind, temperature unaltered
    {
        return temperature;
    }
    else if (windSpeed <= 45)    // high wind
    {
        return
            91.4 - (10.45 + 6.69*sqrt(windSpeed) - 0.447 * windSpeed) *
            (91.4 - temperature)/22.0;
    }
    else
    {
        return (1.6 * temperature - 55.0);
    }
}
