#include "worditer.h"

// implementation of WordStreamIterator class
// Owen Astrachan 7/3/95

WordStreamIterator::WordStreamIterator()
// postcondition: iterator is initialized, IsDone() == true     
{
    myWord = "";
    myDone = true;              // First() must be called 
}

void WordStreamIterator::Open(apstring name)
{
    myInput.open(name.c_str());
}

void WordStreamIterator::First()
// postcondition: first word read from stream myInput
{
    myInput.seekg(0);                   // back to beginning
    myInput.clear();                    // clear the stream
    myDone = ! (myInput >> myWord);
}


apstring WordStreamIterator::Current()
// postcondition: returns current word     
{
    return myWord;
}

bool WordStreamIterator::IsDone()
// postcondition: returns true if sentinel LAST_WORD has
//                been read     
{
    return myDone;
}

void WordStreamIterator::Next()
// precondition: ! IsDone()     
// postcondition: next word from stream myInput read     
{
    if (! IsDone())
    {
        myDone = ! (myInput >> myWord);
    }
}
